Index: code/branches/presentation2/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/branches/presentation2/src/orxonox/controllers/NewHumanController.cc	(revision 6223)
+++ code/branches/presentation2/src/orxonox/controllers/NewHumanController.cc	(revision 6236)
@@ -69,7 +69,8 @@
         controlMode_ = 0;
         acceleration_ = 0;
-        acceleration_ = false;
+        accelerating_ = false;
         firemode_ = -1;
         showArrows_ = true;
+        showOverlays_ = false;
 
         //currentPitch_ = 1;
@@ -129,5 +130,5 @@
         NewHumanController::localController_s = this;
 
-        controlPaused_ = true;
+        controlPaused_ = false;
 
 //HumanController::localController_s->getControllableEntity()->getCamera()->setDrag(true);
@@ -169,17 +170,11 @@
 
                     if ( this->controlMode_ == 0 || ( this->controlMode_ == 1 && this->firemode_ == 1 ) )
-                        alignArrows();
+                    {
+                        if ( this->showOverlays_ )
+                            alignArrows();
+                    }
                     else
                         hideArrows();
-
-                    this->crossHairOverlay_->show();
-                    this->centerOverlay_->show();
                 }
-            }
-            else {
-                this->crossHairOverlay_->hide();
-                this->centerOverlay_->hide();
-
-                hideArrows();
             }
 
@@ -384,7 +379,18 @@
         this->currentYaw_ = 0;
         this->currentPitch_ = 0;
-//         if (this->getControllableEntity() && this->getControllableEntity()->getIdentifier()->getName() == "SpaceShip") {
-//             this->doResumeControl();
-//         }
+        if (this->getControllableEntity() && this->getControllableEntity()->getIdentifier()->getName() == "SpaceShip")
+        {
+            this->showOverlays_ = true;
+            if( !this->controlPaused_ )
+            {
+                this->showOverlays();
+                this->alignArrows();
+            }
+        }
+        else
+        {
+            this->showOverlays_ = false;
+            this->hideOverlays();
+        }
     }
 
@@ -407,15 +413,13 @@
     void NewHumanController::doResumeControl() {
         this->controlPaused_ = false;
-        this->crossHairOverlay_->show();
-        this->centerOverlay_->show();
+        if( this->showOverlays_ ) {
+            this->showOverlays();
+        }
     }
 
     void NewHumanController::doPauseControl() {
         this->controlPaused_ = true;
-
-        this->crossHairOverlay_->hide();
-        this->centerOverlay_->hide();
-
-        hideArrows();
+        
+        this->hideOverlays();
     }
 
@@ -447,4 +451,23 @@
             }
         }
+    }
+
+    void NewHumanController::showOverlays() {
+        this->crossHairOverlay_->show();
+        this->centerOverlay_->show();
+        
+        if (showArrows_) {
+            this->arrowsOverlay1_->show();
+            this->arrowsOverlay2_->show();
+            this->arrowsOverlay3_->show();
+            this->arrowsOverlay4_->show();
+        }
+    }
+
+    void NewHumanController::hideOverlays() {
+        this->crossHairOverlay_->hide();
+        this->centerOverlay_->hide();
+        
+        this->hideArrows();
     }
 
Index: code/branches/presentation2/src/orxonox/controllers/NewHumanController.h
===================================================================
--- code/branches/presentation2/src/orxonox/controllers/NewHumanController.h	(revision 6223)
+++ code/branches/presentation2/src/orxonox/controllers/NewHumanController.h	(revision 6236)
@@ -68,4 +68,6 @@
             void updateTarget();
             void alignArrows();
+            void showOverlays();
+            void hideOverlays();
             void hideArrows();
 
@@ -87,4 +89,5 @@
             int                         firemode_;
             bool                        showArrows_;
+            bool                        showOverlays_;
             ClassTreeMask               targetMask_;
     };