Index: code/branches/presentation2/data/gui/layouts/GraphicsMenu.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/GraphicsMenu.layout	(revision 6235)
+++ code/branches/presentation2/data/gui/layouts/GraphicsMenu.layout	(revision 6238)
@@ -77,5 +77,5 @@
         </Window>
         <Window Type="TaharezLook/StaticText" Name="orxonox/GraphicsAvailable" >
-            <Property Name="Text" Value="Changes in graphics settings are not yet available." />
+            <Property Name="Text" Value="All the graphics functions are not yet available." />
             <Property Name="TextColours" Value="FFFF0000" />
             <Property Name="InheritsAlpha" Value="False" />
Index: code/branches/presentation2/data/gui/layouts/MouseControlsMenu.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/MouseControlsMenu.layout	(revision 6235)
+++ code/branches/presentation2/data/gui/layouts/MouseControlsMenu.layout	(revision 6238)
@@ -16,6 +16,6 @@
             <Property Name="VertFormatting" Value="TopAligned" />
             <Property Name="UnifiedAreaRect" Value="{{0.25,0},{0.325,0},{0.75,0},{0.6,0}}" />
-            <Window Type="TaharezLook/StaticText" Name="orxonox/MouseSensitivity" >
-                <Property Name="Text" Value="Mouse sensitivity" />
+            <Window Type="TaharezLook/StaticText" Name="orxonox/MouseNormalSensitivity" >
+                <Property Name="Text" Value="Sensitivity (normal mode)                                      " />
                 <Property Name="InheritsAlpha" Value="False" />
                 <Property Name="HorzFormatting" Value="HorzCentred" />
@@ -23,5 +23,5 @@
                 <Property Name="VertFormatting" Value="TopAligned" />
                 <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.2,0},{0.95,0},{0.45,0}}" />
-                <Window Type="TaharezLook/HorizontalScrollbar" Name="orxonox/MouseScrollbar" >
+                <Window Type="TaharezLook/HorizontalScrollbar" Name="orxonox/MouseNormalScrollbar" >
                     <Property Name="PageSize" Value="0" />
                     <Property Name="StepSize" Value="1" />
@@ -31,29 +31,48 @@
                     <Property Name="StepSize" Value="0.1" />
                     <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-                    <Property Name="UnifiedAreaRect" Value="{{0.02,0},{0.6,0},{0.98,0},{0.8,0}}" />
-                    <Event Name="ThumbTrackStarted" Function="MouseControlsMenu.MouseControlsMouseScrollbar_started" />
-                    <Event Name="ThumbTrackEnded" Function="MouseControlsMenu.MouseControlsMouseScrollbar_ended" />
-                    <Event Name="ScrollPosChanged" Function="MouseControlsMenu.MouseControlsMouseScrollbar_changed" />
+                    <Property Name="UnifiedAreaRect" Value="{{0.02,0},{0.6,0},{0.565,0},{0.8,0}}" />
+                    <Event Name="ThumbTrackStarted" Function="MouseControlsMenu.MouseControlsMouseNormalScrollbar_started" />
+                    <Event Name="ThumbTrackEnded" Function="MouseControlsMenu.MouseControlsMouseNormalScrollbar_ended" />
+                    <Event Name="ScrollPosChanged" Function="MouseControlsMenu.MouseControlsMouseNormalScrollbar_changed" />
+                </Window>
+                <Window Type="TaharezLook/RadioButton" Name="orxonox/MouseNormalButton" >
+                    <Property Name="Text" Value="Normal mouse input" />
+                    <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                    <Property Name="UnifiedAreaRect" Value="{{0.61,0},{0.5,0},{0.975,0},{0.85,0}}" />
+                    <Event Name="SelectStateChanged" Function="MouseControlsMenu.MouseNormalButton_clicked" />
                 </Window>
             </Window>
-            <Window Type="TaharezLook/StaticText" Name="orxonox/MouseControlMode" >
-                <Property Name="Text" Value="Mouse control mode" />
+            <Window Type="TaharezLook/StaticText" Name="orxonox/MouseDeriveSensitivity" >
+                <Property Name="Text" Value="Sensitivity (derive mode)                                      " />
                 <Property Name="InheritsAlpha" Value="False" />
                 <Property Name="HorzFormatting" Value="HorzCentred" />
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
                 <Property Name="VertFormatting" Value="TopAligned" />
-                <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.55,0},{0.95,0},{0.9,0}}" />
-                <Window Type="TaharezLook/RadioButton" Name="orxonox/MouseControlButton1" >
-                    <Property Name="Text" Value="Default control mode" />
+                <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.55,0},{0.95,0},{0.8,0}}" />
+                <Window Type="TaharezLook/HorizontalScrollbar" Name="orxonox/MouseDeriveScrollbar" >
+                    <Property Name="PageSize" Value="0" />
+                    <Property Name="StepSize" Value="1" />
+                    <Property Name="OverlapSize" Value="0" />
+                    <Property Name="DocumentSize" Value="1" />
+                    <Property Name="ScrollPosition" Value="0" />
+                    <Property Name="StepSize" Value="0.1" />
                     <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-                    <Property Name="UnifiedAreaRect" Value="{{0.03,0},{0.6,0},{0.47,0},{0.8,0}}" />
-                    <Event Name="SelectStateChanged" Function="MouseControlsMenu.MouseControlsDefaultButton_clicked" />
+                    <Property Name="UnifiedAreaRect" Value="{{0.02,0},{0.6,0},{0.565,0},{0.8,0}}" />
+                    <Event Name="ThumbTrackStarted" Function="MouseControlsMenu.MouseControlsMouseDeriveScrollbar_started" />
+                    <Event Name="ThumbTrackEnded" Function="MouseControlsMenu.MouseControlsMouseDeriveScrollbar_ended" />
+                    <Event Name="ScrollPosChanged" Function="MouseControlsMenu.MouseControlsMouseDeriveScrollbar_changed" />
                 </Window>
-                <Window Type="TaharezLook/RadioButton" Name="orxonox/MouseControlButton2" >
-                    <Property Name="Text" Value=".............................................." />
+                <Window Type="TaharezLook/RadioButton" Name="orxonox/MouseDeriveButton" >
+                    <Property Name="Text" Value="Derive mouse input" />
                     <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-                    <Property Name="UnifiedAreaRect" Value="{{0.53,0},{0.6,0},{0.97,0},{0.8,0}}" />
-                    <Event Name="SelectStateChanged" Function="MouseControlsMenu.MouseControls_______Button_clicked" />
+                    <Property Name="UnifiedAreaRect" Value="{{0.61,0},{0.5,0},{0.975,0},{0.85,0}}" />
+                    <Event Name="SelectStateChanged" Function="MouseControlsMenu.MouseDeriveButton_clicked" />
                 </Window>
+            </Window>
+            <Window Type="TaharezLook/Checkbox" Name="orxonox/MouseInvertCheckbox" >
+                <Property Name="Text" Value="Invert mouse" />
+                <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.39,0},{0.85,0},{0.61,0},{0.95,0}}" />
+                <Event Name="CheckStateChanged" Function="MouseControlsMenu.MouseInvertCheckbox_clicked" />
             </Window>
         </Window>
@@ -65,5 +84,5 @@
         </Window>
         <Window Type="TaharezLook/StaticText" Name="orxonox/MouseControlsAvailable" >
-            <Property Name="Text" Value="Changes in mouse controls settings are not yet available." />
+            <Property Name="Text" Value="The button functions are not yet available." />
             <Property Name="TextColours" Value="FFFF0000" />
             <Property Name="InheritsAlpha" Value="False" />