Index: code/branches/presentation2/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- code/branches/presentation2/src/modules/weapons/weaponmodes/HsW01.cc	(revision 6228)
+++ code/branches/presentation2/src/modules/weapons/weaponmodes/HsW01.cc	(revision 6245)
@@ -52,5 +52,5 @@
         RegisterObject(HsW01);
 
-        this->reloadTime_ = 0.5;
+        this->reloadTime_ = 0.25;
         this->damage_ = 15;
         this->speed_ = 2500;
@@ -61,15 +61,9 @@
         this->delayTimer_.stopTimer();
 
-        this->defSndWpnFire_ = new WorldSound(this);
-        this->defSndWpnFire_->setLooping(false);
-        this->setDefaultSound("sounds/Weapon_Laser_shrt.ogg");
+        this->setDefaultSound("sounds/Weapon_HsW01.ogg");
     }
 
     HsW01::~HsW01()
     {
-        if(this->isInitialized())
-        {
-            delete this->defSndWpnFire_;
-        }
     }
 
@@ -106,10 +100,5 @@
     void HsW01::fire()
     {
-        this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->attach(this->defSndWpnFire_);
-        this->defSndWpnFire_->play();
-
         this->delayTimer_.startTimer();
-
-        //this->defSndWpnFire_->stop();
     }
 
@@ -142,13 +131,3 @@
         HsW01::muendungsfeuer();
     }
-
-    void HsW01::setDefaultSound(const std::string& soundPath)
-    {
-        this->defSndWpnFire_->setSource(soundPath);
-    }
-
-    const std::string& HsW01::getDefaultSound()
-    {
-        return this->defSndWpnFire_->getSource();
-    }
 }
Index: code/branches/presentation2/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- code/branches/presentation2/src/modules/weapons/weaponmodes/HsW01.h	(revision 6228)
+++ code/branches/presentation2/src/modules/weapons/weaponmodes/HsW01.h	(revision 6245)
@@ -46,7 +46,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-            void setDefaultSound(const std::string& soundPath);
-            const std::string& getDefaultSound();
-
         private:
             void setMaterial(const std::string& material);
@@ -61,6 +58,4 @@
             float delay_;
             Timer delayTimer_;
-
-            WorldSound* defSndWpnFire_;
     };
 }
Index: code/branches/presentation2/src/modules/weapons/weaponmodes/LightningGun.cc
===================================================================
--- code/branches/presentation2/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 6228)
+++ code/branches/presentation2/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 6245)
@@ -36,4 +36,6 @@
 #include "worldentities/pawns/Pawn.h"
 
+#include "sound/WorldSound.h"
+
 namespace orxonox
 {
@@ -49,4 +51,5 @@
 
         this->setMunitionName("LaserMunition");
+        this->setDefaultSound("sounds/Weapon_LightningGun.ogg");
     }
 
@@ -56,5 +59,5 @@
 
     void LightningGun::fire()
-    {
+    {        
         LightningGunProjectile* projectile = new LightningGunProjectile(this);
         projectile->setMaterial("Flares/LightningBall_");
Index: code/branches/presentation2/src/modules/weapons/weaponmodes/LightningGun.h
===================================================================
--- code/branches/presentation2/src/modules/weapons/weaponmodes/LightningGun.h	(revision 6228)
+++ code/branches/presentation2/src/modules/weapons/weaponmodes/LightningGun.h	(revision 6245)
@@ -42,4 +42,5 @@
 
             virtual void fire();
+
        private:
             float speed_;
Index: code/branches/presentation2/src/modules/weapons/weaponmodes/RocketFire.cc
===================================================================
--- code/branches/presentation2/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 6228)
+++ code/branches/presentation2/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 6245)
@@ -38,4 +38,6 @@
 #include "worldentities/pawns/Pawn.h"
 
+#include "sound/WorldSound.h"
+
 namespace orxonox
 {
@@ -52,4 +54,9 @@
 
         this->setMunitionName("RocketMunition");
+        this->setDefaultSound("sounds/Rocket_Launch.ogg");
+    }
+
+    RocketFire::~RocketFire()
+    {
     }
 
Index: code/branches/presentation2/src/modules/weapons/weaponmodes/RocketFire.h
===================================================================
--- code/branches/presentation2/src/modules/weapons/weaponmodes/RocketFire.h	(revision 6228)
+++ code/branches/presentation2/src/modules/weapons/weaponmodes/RocketFire.h	(revision 6245)
@@ -39,5 +39,5 @@
         public:
             RocketFire(BaseObject* creator);
-            virtual ~RocketFire() {}
+            virtual ~RocketFire();
 
             virtual void fire();