Index: /branches/height_map/src/lib/graphics/importer/vertex_array_model.cc
===================================================================
--- /branches/height_map/src/lib/graphics/importer/vertex_array_model.cc	(revision 6258)
+++ /branches/height_map/src/lib/graphics/importer/vertex_array_model.cc	(revision 6259)
@@ -68,15 +68,17 @@
   PRINTF(4)("drawing the 3D-VertexArrayModels\n");
 
-  glEnableClientState(GL_VERTEX_ARRAY |
-		      GL_TEXTURE_COORD_ARRAY |
-		      GL_NORMAL_ARRAY);
-  glEnableClientState(GL_INDEX_ARRAY);
+  glEnableClientState(GL_VERTEX_ARRAY );
+  glEnableClientState(GL_TEXTURE_COORD_ARRAY );
+  glEnableClientState(GL_NORMAL_ARRAY );
+  glEnableClientState(GL_COLOR_ARRAY );
+
 
   glVertexPointer(3, GL_FLOAT, 0, this->vertices.getArray());
   glNormalPointer(GL_FLOAT, 0, this->normals.getArray());
-  glTexCoordPointer(2, GL_FLOAT, 0, this->texCoords.getArray());  
-
-      glDrawElements(GL_TRIANGLE_STRIP, this->indices.getCount(), GL_UNSIGNED_BYTE, this->indices.getArray());
-/*  for (GLuint i = 1; i < this->stripes.size(); ++i)
+  glTexCoordPointer(2, GL_FLOAT, 0, this->texCoords.getArray());
+  glColorPointer(3, GL_FLOAT, 0, this->colors.getArray());
+
+//      glDrawElements(GL_TRIANGLE_STRIP, this->indices.getCount(), GL_UNSIGNED_BYTE, this->indices.getArray());
+  for (GLuint i = 1; i < this->stripes.size(); ++i)
     {
       glDrawRangeElements(GL_TRIANGLE_STRIP,
@@ -86,5 +88,5 @@
 			  GL_UNSIGNED_BYTE,
 			  this->indices.getArray());
-    }*/
+    }
 }
 
@@ -131,5 +133,5 @@
 
 /**
- *  adds a Texture Coordinate
+ * @brief adds a Texture Coordinate
  * @param u The u coordinate of the TextureCoordinate.
  * @param v The y coordinate of the TextureCoordinate.
@@ -142,4 +144,16 @@
   this->texCoords.addEntry(v);
   this->pModelInfo.numTexCoor++;
+}
+
+/**
+ * @brief adds a new Color
+ * @param r the Red Component of the VertexColor to add.
+ * @param g the Green Component of the VertexColor to add.
+ * @param b the Blue of the VertexColor to add.
+ */
+void VertexArrayModel::addColor(float r, float g, float b)
+{
+  this->colors.addEntry(r, g, b);
+  // FIXME
 }
 
@@ -165,4 +179,5 @@
   this->texCoords.finalizeArray();
   this->normals.finalizeArray();
+  this->colors.finalizeArray();
   this->indices.finalizeArray();
 
@@ -184,25 +199,33 @@
 /////////////
 /**
- * @brief Includes a default model
- *
- * This will inject a Cube, because this is the most basic model.
- */
+* @brief Includes a default model
+*
+* This will inject a Cube, because this is the most basic model.
+*/
 void VertexArrayModel::planeModel()
 {
+  unsigned int sizeX = 20, sizeY = 10;
+
   unsigned int i, j;
-  for (i = 0; i < 20; i++)
+  for (i = 0; i < sizeY; i++)
     {
-      for (j = 0; j < 20; j++)
-	{
-	  this->addVertex((float)i, .5, (float)(j));
-	  this->addNormal(0, 1, 0);
-	  this->addTexCoor((float)i/20.0, (float)j/20.0);
-
-	}
+      for (j = 0; j < sizeX; j++)
+        {
+          this->addVertex((float)i - sizeY/2.0, -(float)i * (float)j/(float)sizeY/(float)sizeX * 10.0 , (float)(j) - sizeX/2.0);
+          this->addNormal((float)i/(float)sizeY, 1, (float)j/(float)sizeX);
+          this->addTexCoor((float)i/(float)sizeY, (float)j/(float)sizeY);
+          this->addColor((float)i/20.0, 0.0, (float)j/20.0);
+        }
     }
-  for (i = 0; i < 20; i++)
+
+  for (i = 0; i < sizeY-1; i++)
+  {
+    for (j = 0; j < sizeX; j++)
     {
-      this->addIndice(i);
-      this->addIndice(i+20);
+      this->addIndice(sizeX*i + j);
+      this->addIndice(sizeX*(i+1) + j);
     }
-}
+    if (i < sizeY -1 )
+      this->newStripe();
+  }
+}
Index: /branches/height_map/src/lib/graphics/importer/vertex_array_model.h
===================================================================
--- /branches/height_map/src/lib/graphics/importer/vertex_array_model.h	(revision 6258)
+++ /branches/height_map/src/lib/graphics/importer/vertex_array_model.h	(revision 6259)
@@ -39,9 +39,11 @@
   void addNormal(float x, float y, float z);
   void addTexCoor(float u, float v);
+  void addColor(float r, float g, float b);
+
   void addIndice(GLubyte indice);
 
   void finalize();
 
-  // 
+  //
   void planeModel();
 
@@ -55,4 +57,5 @@
   tArray<GLfloat>            normals;         //!< The Array that handles the Normals.
   tArray<GLfloat>            texCoords;       //!< The Array that handles the VertexTextureCoordinates.
+  tArray<GLfloat>            colors;          //!< The Array that handles Colors.
 
   tArray<GLubyte>            indices;         //!< The Array that tells us what Vertex is connected to which other one.