Index: /branches/height_map/src/lib/graphics/importer/vertex_array_model.cc
===================================================================
--- /branches/height_map/src/lib/graphics/importer/vertex_array_model.cc	(revision 6262)
+++ /branches/height_map/src/lib/graphics/importer/vertex_array_model.cc	(revision 6263)
@@ -224,9 +224,9 @@
     for (j = 0; j < sizeX; j++)
     {
-      this->addIndice(sizeY*i + j);
-      this->addIndice(sizeY*(i+1) + j);
-    }
+      this->addIndice( sizeY*i + j );
+      this->addIndice( sizeY*(i+1) + j );
+    }
+    this->newStripe();
     this->debug();
-    this->newStripe();
   }
 }
Index: /branches/height_map/src/lib/graphics/importer/vertex_array_model.h
===================================================================
--- /branches/height_map/src/lib/graphics/importer/vertex_array_model.h	(revision 6262)
+++ /branches/height_map/src/lib/graphics/importer/vertex_array_model.h	(revision 6263)
@@ -11,5 +11,4 @@
 #include "glincl.h"
 
-#include "array.h"
 #include <vector>
 
Index: /branches/height_map/src/story_entities/world.cc
===================================================================
--- /branches/height_map/src/story_entities/world.cc	(revision 6262)
+++ /branches/height_map/src/story_entities/world.cc	(revision 6263)
@@ -73,4 +73,6 @@
 #include "playable.h"
 
+#include "vertex_array_model.h"
+
 
 SHELL_COMMAND(speed, World, setSpeed);
@@ -384,9 +386,17 @@
   localCamera->lookAt(playable);
 //  this->localPlayer->setParentMode(PNODE_ALL);
-  if (sky != NULL)
-  {
-    this->sky->setParent(this->localCamera);
-    this->sky->setParentMode(PNODE_MOVEMENT);
-  }
+//   if (sky != NULL)
+//   {
+//     this->sky->setParent(this->localCamera);
+//     this->sky->setParentMode(PNODE_MOVEMENT);
+//   }
+
+  VertexArrayModel* mod = new VertexArrayModel;
+  mod->planeModel();
+  mod->finalize();
+  mod->debug();
+  this->TEST = mod;
+  this->testMat = new Material;
+  this->testMat->setDiffuse( 1,1,1);
 
   // initialize debug coord system
@@ -826,4 +836,6 @@
   GraphicsEngine::getInstance()->draw();
   //TextEngine::getInstance()->draw();
+  this->testMat->select();
+  this->TEST->draw();
 }
 
Index: /branches/height_map/src/story_entities/world.h
===================================================================
--- /branches/height_map/src/story_entities/world.h	(revision 6262)
+++ /branches/height_map/src/story_entities/world.h	(revision 6263)
@@ -25,4 +25,7 @@
 class OggPlayer;
 template<class T> class tList;
+
+#include "vertex_array_model.h"
+#include "material.h"
 
 //! The game world
@@ -116,5 +119,6 @@
     WorldEntity* sky;                   //!< The Environmental Heaven of orxonox @todo insert this to environment insted
     Terrain* terrain;                   //!< The Terrain of the World.
-
+    Material* testMat;
+    Model*   TEST;
     GLuint objectList;                  //!< temporary: @todo this will be ereased soon
     tList<WorldEntity>* entities;       //!< A template List of all entities. Every moving thing should be included here, and world automatically updates them.
Index: /branches/height_map/src/world_entities/terrain.cc
===================================================================
--- /branches/height_map/src/world_entities/terrain.cc	(revision 6262)
+++ /branches/height_map/src/world_entities/terrain.cc	(revision 6263)
@@ -42,5 +42,5 @@
   this->init();
 
-  this->tmp_mat = new Material(); 
+  this->tmp_mat = new Material();
   tmp_mat->setTransparency(1.0);
   tmp_mat->setIllum(0.3);
@@ -57,13 +57,13 @@
   tmp_mat->ambientTexture = NULL;
  // tmp_mat->specularTexture = NULL;
-  
+
   // this->loadParams(root);
 
  char* heightmapName = ResourceManager::getFullName("pictures/heightmapHello.bmp");
  char* colourmapName = ResourceManager::getFullName("pictures/heightmapHelloCM.bmp");
- hm = new HeightMap(heightmapName, colourmapName);
- hm->scale(Vector(23.0f,1.7f,23.0f));
- hm->load();
- this->model=hm;
+//  hm = new HeightMap(heightmapName, colourmapName);
+//  hm->scale(Vector(23.0f,1.7f,23.0f));
+//  hm->load();
+//  this->model=hm;
 
  /*	this->model =  new HeightMap();
@@ -126,5 +126,5 @@
 
       this->model->finalize(); */
-   
+
  /*if (this->model != NULL)
     this->ssp = new SpatialSeparation((AbstractModel*)this->model, 10.0f);*/
@@ -224,9 +224,9 @@
   Vector tmpRot = this->getAbsDir().getSpacialAxis();
   glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-	
+
    //this->tmp_mat->select();
-	
-
-  hm->draw();
+
+
+  //hm->draw();
  /* if (this->objectList)
     glCallList(this->objectList);